DealershipApp/DealershipMVC/Models/FilterViewModel (2).cs
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;

namespace DealershipMVC.Models
{
   public class FilterViewModel
   {
      public FilterViewModel()
      {
         Years = new List<SelectListItem>();
         Makes  = new List<SelectListItem>();
         Models = new List<SelectListItem>();
      }

      public int Miles { get; set; }

      [RegularExpression(@"\d{4}")]
      public string Year { get; set; }

      public string Make { get; set; }
      public string Model { get; set; }

      [RegularExpression(@"\d{5}")]
      public string ZipCode { get; set; }

      public List<SelectListItem> Years { get; set; } 
      public List<SelectListItem> Makes { get; set; } 
      public List<SelectListItem> Models { get; set; }
      public string City { get; set; }
      public string State { get; set; }
      public bool UseLoc { get; set; }
      public double Lat { get; set; }
      public double Lng { get; set; }
   }
}

DealershipApp/DealershipMVC/Models/FilterViewModel.cs
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;

namespace DealershipMVC.Models
{
   public class FilterViewModel
   {
      public FilterViewModel()
      {
         Years = new List<SelectListItem>();
         Makes  = new List<SelectListItem>();
         Models = new List<SelectListItem>();
      }

      public int Miles { get; set; }

      [RegularExpression(@"\d{4}")]
      public string Year { get; set; }

      public string Make { get; set; }
      public string Model { get; set; }

      [RegularExpression(@"\d{5}")]
      public string ZipCode { get; set; }

      public List<SelectListItem> Years { get; set; } 
      public List<SelectListItem> Makes { get; set; } 
      public List<SelectListItem> Models { get; set; }
      public string City { get; set; }
      public string State { get; set; }
      public bool UseLoc { get; set; }
      public double Lat { get; set; }
      public double Lng { get; set; }
   }
}

DealershipApp/DealershipMVC/Controllers/LocatorController.cs
using System.Linq;
using System.Text.RegularExpressions;
using System.Web.Mvc;
using DealershipModel.Entities;
using DealershipMVC.DealershipService;
using DealershipMVC.Models;
using Microsoft.Ajax.Utilities;

namespace DealershipMVC.Controllers
{
   public class LocatorController : Controller
   {
      private static readonly DealershipServiceClient Client = new DealershipServiceClient();

      public ActionResult Locations()
      {
         return View(Client.Dealerships(null, null, null, null, null));
      }

      public ActionResult FilterLocations()
      {
         var data = Client.VehicleFilterData();

         var model = new FilterViewModel
         {
            Years = data["Year"].Select(x => new SelectListItem
            {
               Value = x,
               Text = x,
               Selected = false
            }).ToList(),
            Makes = data["Make"].Select(x => new SelectListItem
            {
               Value = x,
               Selected = false,
               Text = x,
            }).ToList(),
            Models = data["Model"].Select(x => new SelectListItem
            {
               Value = x,
               Selected = false,
               Text = x,
            }).ToList()
         };
         model.Years.Add(new SelectListItem
         {
            Selected = true,
            Text = "Any Year"
         }); model.Makes.Add(new SelectListItem
         {
            Selected = true,
            Text = "Any Make"
         }); model.Models.Add(new SelectListItem
         {
            Selected = true,
            Text = "Any Model"
         });
         return PartialView(model);
      }

      [HttpPost]
      public ActionResult FilterLocations(int miles, string zipCode, string year, string make, string model, string city, string state, double lat, double lng, bool useLoc)
      {
         Address address = null;
         if (!zipCode.IsNullOrWhiteSpace() && Regex.Match(zipCode, @"\d{5}").Success)
         {
            address = new Address()
            {
               ZipCode = zipCode
            };
         }
         if (!city.IsNullOrWhiteSpace() && !state.IsNullOrWhiteSpace())
            address = new Address()
            {
               City = city,
               State = state,
            };
         if (!(lat == 0 || lng == 0) && useLoc)
            address = new Address()
            {
               Latitude = lat,
               Longitude = lng
            };
         if (!(year != null && Regex.Match(year, @"\d{4}").Success))
         {
            year = null;
         }
         return PartialView("Dealerships",
            Client.Dealerships(
               address,
               miles == 0 ? (int?)null : miles,
               make.Equals("Any Make") ? null : make,
               model.Equals("Any Model") ? null : model,
               year
               ));
      }

      public ActionResult Dealership(int id)
      {
         var dealer = Client.Dealership(id);
         return PartialView("Dealership", dealer);
      }
   }
}

DealershipApp/DealershipMVC/Controllers/RegisterController.cs
using System;
using System.Web.Mvc;
using DealershipModel.Entities;
using DealershipMVC.DealershipService;
using WCFStatusResponse;

namespace DealershipMVC.Controllers
{
   public class RegisterController : Controller
   {
      // GET: Register
      public ActionResult Register()
      {
         var dealership = new Dealership();
         return View(dealership);
      }

      [HttpPost]
      public ActionResult Register(Dealership dealership)
      {
         try
         {
            var client = new DealershipServiceClient();
            var response = client.AddDealership(dealership);
            if (typeof(ErrorResponse) != response.GetType()) return RedirectToAction("Locations", "Locator");
            ViewBag.ErrorMessage(response.Message);
         }
         catch (Exception e)
         {
            ViewBag.ErrorMessage(e.Message);
            throw;
         }
         return View(dealership);
      }

   }
}

DealershipApp/DealershipMVC/Controllers/VehicleController.cs
using System.Linq;
using System.Web.Mvc;
using DealershipMVC.DealershipService;

namespace DealershipMVC.Controllers
{
   public class VehicleController : Controller
   {
      private static readonly DealershipServiceClient Client = new DealershipServiceClient();
      // GET: Vehicle
      public ActionResult Index()
      {

         return View(Client.Vehicles().ToList());
      }

      public ActionResult Vehicle(int id)
      {
         return View(Client.Vehicle(id));
      }

      public ActionResult DealerVehicles(int dealerId)
      {
         return PartialView(Client.DealerVehicles(dealerId));
      }
   }
}

DealershipApp/DealershipMVC/Views/Locator/Dealership.cshtml
@model DealershipModel.Entities.Dealership
<div class="col-sm-6">

   <h2>@Model.Address.City (Dealer #:@Model.Id.ToString("D5"))</h2>
   <h6>@Model.Address.FullAddress</h6>
   <p>Managed by: @Model.Manager </p>
   <p><abbr title="Phone">P:</abbr> @Model.Phone</p>
</div>
<div class="col-sm-6">

   <table>
      <thead>
      <th>Day</th>
      <th>Hours</th>
      </thead>
      <tr>
         <td>M-F</td>
         <td>
            Sales: 8 AM - 10 PM<br />
            Service: 8 AM - 6 PM
         </td>
      </tr>
      <tr>
         <td>Sat</td>
         <td>
            Sales: 8 AM - 6PM PM<br />
            Service: 12 PM - 6 PM
         </td>
      </tr>
      <tr>
         <td>Sun</td>
         <td>
            Closed
         </td>
      </tr>
   </table>
</div>

<div class="col-sm-12">
   <a id="directions" href="http://maps.google.com/maps?saddr=(CurrentAddress)&daddr=(@Model.Address.FullAddress)" onclick="UpdateLocation()" class="btn btn-info" target="_new">Directions</a>
</div>

<input type="hidden" id="DealerLat" name="DealerLat" value="@Model.Address.Latitude" />
<input type="hidden" id="DealerLng" name="DealerLng" value="@Model.Address.Longitude" />

DealershipApp/DealershipMVC/Views/Locator/Dealerships.cshtml
@model DealershipModel.Entities.Dealership[]

@foreach (var dealership in Model)
{
   <li role="presentation">
      @Ajax.ActionLink($"{dealership.Address.City}, {dealership.Address.State} (Store #:{dealership.Id.ToString("D5")})",
          "Dealership",
          new RouteValueDictionary
          {
             {"id", dealership.Id}
          }, new AjaxOptions()
          {
             HttpMethod = "Post",
             UpdateTargetId = "DealershipDetails",
             OnSuccess = "FocusMap"
          })
   </li>

}

@if (Model.Length == 0)
{
   <text>
      No dealerships match your search requirements. Please expand your search criteria.
   </text>
}

DealershipApp/DealershipMVC/Views/Locator/FilterLocations.cshtml
@using System.Collections.Generic
@model DealershipMVC.Models.FilterViewModel


@using (Ajax.BeginForm("FilterLocations", new AjaxOptions { HttpMethod = "Post", UpdateTargetId = "dealerList", OnSuccess = "" }))
{
   <div>
      <p>Only show dealerships that match the following criteria.</p>
   </div>
   <div>
      <p id="geoLocOption" class="collapse">@Html.CheckBoxFor(m => m.UseLoc) Use Current Location?</p>
      Dealerships that are @Html.EditorFor(m => m.Miles) miles from
      <span id="LocFilter1" class="collapse">Current Location</span>
      <span id="LocFilter2">
         @Html.TextBoxFor(m => m.ZipCode, new Dictionary<string, object>
      {
         {"placeholder", "Postal Code"}
      })
         or @Html.TextBoxFor(m => m.City, new Dictionary<string, object>
         {
            {"placeholder", "City"}
         })
         @Html.TextBoxFor(m => m.State, new Dictionary<string, object>
      {
         {"placeholder", "State"}
      })
      </span>
   </div>
   <div>
      Dealerships that have vehicles that are:

      @Html.DropDownListFor(m => m.Year, Model.Years)
      @Html.DropDownListFor(m => m.Make, Model.Makes)
      @Html.DropDownListFor(m => m.Model, Model.Models)
   </div>
   <button type="submit" class="btn">Update Filter</button>
   @Html.HiddenFor(m => m.Lat)
   @Html.HiddenFor(m => m.Lng)
}

DealershipApp/DealershipMVC/Views/Locator/Locations.cshtml
@using System.Linq
@using System.Web.Optimization
@model DealershipModel.Entities.Dealership[]

@{
   ViewBag.Title = "title";
}

@section map{
   <div id="dealer">
      <div id="map"></div>

   </div>
}

@section sideNav{
   <ul class="nav nav-pills nav-stacked">
      <li role="presentation">
         <a id="filter" href="#">Filter Locations</a>
      </li>
   </ul>
   <ul id="dealerList" class="nav nav-pills nav-stacked">

      @*@foreach (var dealership in Model)
         {
            <li role="presentation">
               <a id="@("dealer" + dealership.Id)" href="#">@dealership.Address.City, @dealership.Address.State (Store #:@dealership.Id.ToString("D5"))</a>
               @Html.Hidden("dealerDist" + dealership.Id)
            </li>
         }*@
      @{
         Html.RenderPartial("Dealerships");
      }
   </ul>
}

@section js{
   @Scripts.Render("~/js/Ajax")
   <script>$("#loc").addClass("active")</script>
   <script>
      $("#filter").click(function() {
         $("#filter").toggleClass("active");
         $("#filterData").toggleClass("collapse");
      })
   </script>
   <script src="https://maps.googleapis.com/maps/api/js?callback=initMap" async defer></script>

   <script>
      var map;
      var pos;
      var FocusMap;
      $("#UseLoc").on('change', function(e) {
         if ($(this).is(':checked')) {
            $("#LocFilter1").removeClass("collapse");
            $("#LocFilter2").addClass("collapse");
         } else {
            $("#LocFilter1").addClass("collapse");
            $("#LocFilter2").removeClass("collapse");
         }
      });

      function initMap() {

         var mapDiv = document.getElementById('map');
         var bounds = new google.maps.LatLngBounds();
         map = new google.maps.Map(mapDiv, {
            center: { lat: @(Model.Sum(d => d.Address.Latitude)/Model.Length), lng: @(Model.Sum(d => d.Address.Longitude)/Model.Length) },
            zoom: 8
         });

         map.fitBounds(bounds);
         var infoWindow = new google.maps.InfoWindow({ map: map });
         if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position) {
               pos = {
                  lat: position.coords.latitude,
                  lng: position.coords.longitude
               };

               infoWindow.setPosition(pos);
               infoWindow.setContent('Your Location.');
               $("#geoLocOption").removeClass("collapse");
               $("#UseLoc").checked=true;
               $("#Lat").val(pos.lat);
               $("#Lng").val(pos.lng);
            }, function() {
               handleLocationError(true, infoWindow, map.getCenter());
            });
         } else {
            // Browser doesn't support Geolocation
            handleLocationError(false, infoWindow, map.getCenter());
         }

         @foreach (var dealer in Model)
         {
            <text>
         var @("marker" + dealer.Id) = new google.maps.Marker({
            position: {
               lat: @(dealer.Address.Latitude),
               lng: @(dealer.Address.Longitude)
            },
            map: map,
            title: 'Hello World!'
         });


         bounds.extend(@("marker" + dealer.Id).getPosition());
         </text>
         }
         FocusMap = function(e) {
            map.setZoom(17);
            map.panTo({
               lat: parseFloat($("#DealerLat").val()),
               lng: parseFloat($("#DealerLng").val())
            });
         };

      }

      function UpdateLocation(parameters) {
         $("#directions").href($("#directions").href().replace("CurrentAddress", pos.lat + "," + pos.lng));
      }

      function handleLocationError(browserHasGeolocation, infoWindow, pos) {
         $("#geoLocOption").addClass("collapse");
         infoWindow.setPosition(pos);
         infoWindow.setContent(browserHasGeolocation ?
            'Error: The Geolocation service failed.' :
            'Error: Your browser doesn\'t support geolocation.');
      }


   </script>


}

<div id="filterData" class="collapse">
   @Html.Action("FilterLocations")

</div>

<div id="DealershipDetails">
   <h2 id="locationName"></h2>
   <h6 id="address"></h6>
   <p id="manager"></p>
   <div id="directions"></div>
</div>

DealershipApp/DealershipMVC/Views/Register/Register.cshtml
@model DealershipModel.Entities.Dealership

@{
   ViewBag.Title = "title";
}
@using (Html.BeginForm())
{

   <div class="col-sm-2 register">



      @Html.TextBoxFor(m => m.Manager, new Dictionary<string, object>
      {
         {"placeholder", "Manager Name"}
      })
      @Html.TextBoxFor(m => m.Phone, new Dictionary<string, object>
      {
         {"placeholder", "Phone Number"}
      })
      @Html.TextBoxFor(m => m.Address.StreetAddress, new Dictionary<string, object>
      {
         {"placeholder", "Street Address"}
      })
      @Html.TextBoxFor(m => m.Address.City, new Dictionary<string, object>
      {
         {"placeholder", "City"}
      })
      @Html.TextBoxFor(m => m.Address.State, new Dictionary<string, object>
      {
         {"placeholder", "State"}
      })
      @Html.TextBoxFor(m => m.Address.ZipCode, new Dictionary<string, object>
      {
         {"placeholder", "Postal Code"}
      })
      
      <button type="submit" class="btn btn-info">Register Dealer</button>
   </div>
   <div class="col-sm-10">
      <div id="dealer">
         <div id="map"></div>
         <div id="MapError"></div>
      </div>
   </div>


   <div id="MapError"></div>
}
@section SideNav{
   <h2>Instructions</h2>
   <ul>
      <li>Enter a manager name</li>
      <li>Enter a phone Number</li>
      <li>Enter a street Address</li>
      <li>Enter either a zip code or City and State</li>
   </ul>
   <p>Your Street address will automatically be geocoded and standerdized when saved to our database.</p>
   <div class="alert-warning text-center">
      <p class="warning">Warning: your Dealership will not be visible in Locations untill you have vehicles in stock.</p>
   </div>
   <div class="alert-info text-center">
      <p class="info">Note: Adding Vehicles to your stock is not part of this application, please have a good day.</p>

   </div>

}

@section js{
   <script>
      $("#reg").addClass("active");
   </script>
   @*?callback=initMap*@
   <script src="https://maps.googleapis.com/maps/api/js"></script>

   @*<script src="~/scripts/MyGoogle.js"></script>*@

   <script>
      var map;
      var pos;
      var FocusMap;
      var infoWindow;

      function initMap() {

         var mapDiv = document.getElementById('map');
         var bounds = new google.maps.LatLngBounds();
         map = new google.maps.Map(mapDiv, {
            zoom: 8
         });

         map.fitBounds(bounds);
         infoWindow = new google.maps.InfoWindow({ map: map });
         if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position) {
               pos = {
                  lat: position.coords.latitude,
                  lng: position.coords.longitude
               };

            }, function() {
               handleLocationError(true, infoWindow, map.getCenter());
            });
         } else {
            // Browser doesn't support Geolocation
            handleLocationError(false, infoWindow, map.getCenter());
         }

         FocusMap = function(e) {
            map.setZoom(17);
            map.panTo({
               lat: parseFloat($("#DealerLat").val()),
               lng: parseFloat($("#DealerLng").val())
            });
         };

      }

      $("#Address_StreetAddress").on("change", function (e) {
         UpdateLocation();
      });
      $("#Address_City").on("change", function (e) {
         UpdateLocation();
      });
      $("#Address_State").on("change", function (e) {
         UpdateLocation();
      }); $("#Address_ZipCode").on("change", function (e) {
         UpdateLocation();
      });

      function handleLocationError(browserHasGeolocation, infoWindow, pos) {
         $("#geoLocOption").addClass("collapse");
         infoWindow.setPosition(pos);
         infoWindow.setContent(browserHasGeolocation ?
            'Error: The Geolocation service failed.' :
            'Error: Your browser doesn\'t support geolocation.');
      }

      function UpdateLocation() {
         var geocoder = new google.maps.Geocoder();
         geocoder.geocode({ 'address': $("#Address_StreetAddress").val() + " " + $("#Address_City").val() + " " + $("#Address_State").val() + " " + $("#Address_ZipCode").val() },
            function(results, status) {
               if (status == google.maps.GeocoderStatus.OK) {
                  pos = results[0].geometry.location;
                  infoWindow.setPosition(pos);
                  infoWindow.setContent('Your Location.');
                  map.setZoom(17);
                  map.setCenter(pos);
               } else {
                  $("#MapError").html("Geocode was not successful for the following reason: " + status);
               }
            });

      }


   </script>
<script>
      initMap();
</script>

}

DealershipApp/DealershipMVC/Views/Shared/_Layout.cshtml
@using System.Web.Optimization

<!DOCTYPE html>

<html>
<head>
   <meta name="viewport" content="width=device-width" />
   <title>@ViewBag.Title</title>
   @Styles.Render("~/css/Bootstrap")
</head>
<body>
   <header>
      <nav class="navbar navbar-default">
         <div class="container-fluid">
            <!-- Brand and toggle get grouped for better mobile display -->
            <div class="navbar-header">
               <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
                  <span class="sr-only">Toggle navigation</span>
                  <span class="icon-bar"></span>
                  <span class="icon-bar"></span>
                  <span class="icon-bar"></span>
               </button>
               <a class="navbar-brand" href="#">My dealer</a>
            </div>
            <!-- Collect the nav links, forms, and other content for toggling -->
            <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
               <ul class="nav navbar-nav">
                  <li id="car">@Html.ActionLink("Cars", "Index", "Vehicle")</li>
                  <li id="loc">@Html.ActionLink("Locations", "Locations", "Locator")</li>
                  <li id="reg">@Html.ActionLink("Register", "Register", "Register")</li>
               </ul>
               <ul class="nav navbar-nav navbar-right"></ul>
            </div><!-- /.navbar-collapse -->
         </div><!-- /.container-fluid -->
      </nav>
   </header>
   <main>
      <div class="col-xl-12">
         @RenderSection("map", required: false)
      </div>
      <div class="col-sm-3">
         @RenderSection("sideNav")
      </div>
      <div class="col-sm-9">
         @RenderBody()
      </div>
   </main>
   <footer></footer>
   @Scripts.Render("~/js/JQuery")
   @Scripts.Render("~/js/Bootstrap")

   @RenderSection("js", false)
</body>
</html>

DealershipApp/DealershipMVC/Views/Vehicle/DealerVehicles.cshtml
@model DealershipModel.Entities.Vehicle[]

<ul>
   @foreach (var v in Model)
   {
      <li>@Html.ActionLink($"{v.Year} {v.Make} {v.Model}","Vehicle",new { id = v.Id})</li>
   }
</ul>

DealershipApp/DealershipMVC/Views/Vehicle/Index (2).cshtml
@model System.Collections.Generic.IEnumerable<DealershipModel.Entities.Vehicle>

@{
   ViewBag.Title = "title";
}
<table>
   <thead>
      <tr>
         <th>Stock Number</th>
         <th colspan="3" class="model">Vehicle</th>
         <th>Dealership</th>
         <th>Directions</th>

      </tr>

   <tr>
      <th></th>
      <th>Year</th>
      <th>Make</th>
      <th class="model">Model</th>
      <th></th>
      <th></th>
   </tr>
   </thead>
   @foreach (var vehicle in Model)
   {
      <tr>
         <td>@Html.ActionLink(@vehicle.Id.ToString("D5"),"Vehicle", new {id= vehicle.Id} )</td>
         <td>@vehicle.Year</td>
         <td>@vehicle.Make</td>
         <td class="model">@vehicle.Model</td>
         @if (vehicle.Dealership != null)
         {
            <td>Dealer #@vehicle.Dealership.Id.ToString("D5") (@vehicle.Dealership.Address.City, @vehicle.Dealership.Address.State)</td>
            <td><a href="https://www.google.com/maps?daddr=@vehicle.Dealership.Address.FullAddress" target="_new">Directions To Dealer #:@vehicle.Dealership.Id.ToString("D5")</a></td>
         }
         else
         {
            <td class="alert-danger" colspan="2">Sold</td>
         }
      </tr>
   }

</table>

@section sideNav{
   <h2>Featured Partners</h2>
   <a href="http://ford.com" target="_blank">
   <img src="https://manuals4u.com.au/wp-content/uploads/2011/11/ford-banner.jpg" alt="Advert" style="width: 100%" />
   <img src="http://int.www.northpoint.com.au/images/ford-banner.png" alt="Advert" style="width: 100%" />
   <img src="http://holmanford.com/img/Ford_Banner_060313.jpg" alt="Advert" style="width: 100%" />
</a>
}

@section js{
   <script>
      $("car").addClass("active");
   </script>
}

DealershipApp/DealershipMVC/Views/Vehicle/Index.cshtml
@model System.Collections.Generic.IEnumerable<DealershipModel.Entities.Vehicle>

@{
   ViewBag.Title = "title";
}
<table>
   <thead>
      <tr>
         <th>Stock Number</th>
         <th colspan="3" class="model">Vehicle</th>
         <th>Dealership</th>
         <th>Directions</th>

      </tr>

      <tr>
         <th></th>
         <th>Year</th>
         <th>Make</th>
         <th class="model">Model</th>
         <th></th>
         <th></th>
      </tr>
   </thead>
   @foreach (var vehicle in Model)
   {
      <tr>
         <td>@Html.ActionLink(@vehicle.Id.ToString("D5"), "Vehicle", new { id = vehicle.Id })</td>
         <td>@vehicle.Year</td>
         <td>@vehicle.Make</td>
         <td class="model">@vehicle.Model</td>
         @if (vehicle.Dealership != null)
         {
            <td>Dealer #@vehicle.Dealership.Id.ToString("D5") (@vehicle.Dealership.Address.City, @vehicle.Dealership.Address.State)</td>
            <td><a href="https://www.google.com/maps?daddr=@vehicle.Dealership.Address.FullAddress" target="_new">Directions To Dealer #:@vehicle.Dealership.Id.ToString("D5")</a></td>
         }
         else
         {
            <td class="alert-danger" colspan="2">Sold</td>
         }
      </tr>
   }

</table>

@section sideNav{
   <h2>Featured Partners</h2>
   <a href="http://ford.com" target="_blank">
      <img src="https://manuals4u.com.au/wp-content/uploads/2011/11/ford-banner.jpg" alt="Advert" style="width: 100%" />
      <img src="http://int.www.northpoint.com.au/images/ford-banner.png" alt="Advert" style="width: 100%" />
      <img src="http://holmanford.com/img/Ford_Banner_060313.jpg" alt="Advert" style="width: 100%" />
   </a>
}

@section js{
   <script>
      $("car").addClass("active");
   </script>
}

DealershipApp/DealershipMVC/Views/Vehicle/Vehicle.cshtml
@using DealershipModel.Entities
@model DealershipModel.Entities.Vehicle

@{
   ViewBag.Title = "title";
}

<img class="col-sm-6" src="@Model.ImgURL" alt="@Model.Year @Model.Make @Model.Model"/>
<div class="col-sm-6">

   <h2>@Model.Year @Model.Make @Model.Model</h2>

   <p>This vehicle for sell at Dealership #@Model.Dealership.Id.ToString("D5")</p>

   <small>Call @Model.Dealership.Phone for more details about this vehicle</small>

</div>


@section map
{
   <div id="dealer">
      <div id="map"></div>
   </div>
}

@section sideNav
{
   <H3>Other Vehicles located at this Dealer</H3>
   @Html.Action("DealerVehicles", new {dealerid = Model.Dealership.Id})
}

@section js
{
   <script>
      $("#car").addClass("active");
   </script>
   <script src="https://maps.googleapis.com/maps/api/js?callback=initMap" async defer></script>

   <script>
      var map;
      var pos;

      function initMap() {

         var mapDiv = document.getElementById('map');
         map = new google.maps.Map(mapDiv, {
            center: {
               lat: @Model.Dealership.Address.Latitude,
               lng: @Model.Dealership.Address.Longitude,
            },
            zoom: 17
         });
         var marker = new google.maps.Marker(
         {
            position: {
               lat: @Model.Dealership.Address.Latitude,
               lng: @Model.Dealership.Address.Longitude,
            },
            map: map,
            title: "Dealership #@Model.Dealership.Id"
         });
         if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position) {
               pos = {
                  lat: position.coords.latitude,
                  lng: position.coords.longitude
               };

               infoWindow.setPosition(pos);
               infoWindow.setContent('Your Location.');
               $("#geoLocOption").removeClass("collapse");
               $("#UseLoc").checked=true;
               $("#Lat").val(pos.lat);
               $("#Lng").val(pos.lng);
            }, function() {
               handleLocationError(true, infoWindow, map.getCenter());
            });
         } else {
            // Browser doesn't support Geolocation
            handleLocationError(false, infoWindow, map.getCenter());
         }
      }
      function handleLocationError(browserHasGeolocation, infoWindow, pos) {
         $("#geoLocOption").addClass("collapse");
         infoWindow.setPosition(pos);
         infoWindow.setContent(browserHasGeolocation ?
            'Error: The Geolocation service failed.' :
            'Error: Your browser doesn\'t support geolocation.');
      }

   </script>
}